var vows = require('vows')
var assert = require('assert')
var request = require('request');
var runTestServer = require('./helper.js').runTestServer
var copyProcessEnv = require('./helper.js').copyProcessEnv

vows.describe('Web @Web.Validations.Input validations 1').addBatch({
	"When I do a request with invalid params": {
		topic: function() {
			runTestServer.call(this,"validateParams", function(finishWithServer) {
				request('http://127.0.0.1:3504/blogs/superBlog', function (err, response, body) {
						if(err) {
							finishWithServer(err, null)
							return
						} else {
							finishWithServer(null, {
								err: err,
								response: response,
								body: body
							})
						}
					}) // request
			},{DONT_PRINT_TO_CONSOLE:false}) // runTestServer
		},
		"I should get the errors in the response and 404": function(res){
			assert.isEmpty(res.stderr)
			assert.isNull(res.testErr)
			assert.deepEqual(JSON.parse(res.testRes.body), {
				"messages": [
				{
					"type": "error",
					"path": "/params/blog_name",
					"message": "Invalid Blog"
				}
				]
			})
			assert.equal(res.testRes.response.statusCode, 404)
		}
	}
}).export(module);

