var vows = require('vows')
var assert = require('assert')
var request = require('request');
var runTestServer = require('./helper.js').runTestServer
var copyProcessEnv = require('./helper.js').copyProcessEnv

vows.describe('Web @Web.Validations.Input validations 2').addBatch({
	"When I do a request with invalid body": {
		topic: function() {
			runTestServer.call(this,"validateBody", function(finishWithServer) {
				request.post({
					url: 'http://127.0.0.1:3505/blogs',
					body: "name=&description=",
					headers: {
				       'content-type': 'application/x-www-form-urlencoded'
				  }
				}, function (err, response, body) {
						if(err) {
							finishWithServer(err, null)
							return
						} else {
							finishWithServer(null, {
								err: err,
								response: response,
								body: body
							})
						}
					}) // request
			},{DONT_PRINT_TO_CONSOLE:true}) // runTestServer
		},
		"I should get the errors in the response and 404": function(res){
			assert.isEmpty(res.stderr)
			assert.isNull(res.testErr)
			assert.deepEqual(JSON.parse(res.testRes.body), {
				"messages": [
				{
					"type": "error",
					"path": "/body/name",
					"message": "Can't be empty"
				},
				{
					"type": "error",
					"path": "/body/description",
					"message": "Can't be empty"
				}
				]
			})
			assert.equal(res.testRes.response.statusCode, 422)
		}
	}
}).export(module);

