var vows = require('vows')
var assert = require('assert')
var request = require('request');
var runTestServer = require('./helper.js').runTestServer
var copyProcessEnv = require('./helper.js').copyProcessEnv

vows.describe('Web 1').addBatch({
	"When I run a server with a single expression": {
		topic: function() {
			runTestServer.call(this,"basicService", function(finishWithServer) {
				request('http://127.0.0.1:3501/hello', function (err, response, body) {
					
						if(err) {
							finishWithServer(err, null)
							return
						} else {
							finishWithServer(null, {
								err: err,
								response: response,
								body: body
							})
						}
					}) // request
			},{DONT_PRINT_TO_CONSOLE:false}) // runTestServer
		},
		"I should see the value in the response as JSON string": function(res){
			assert.isEmpty(res.stderr)
			assert.isNull(res.testErr)
			assert.equal(res.testRes.response.statusCode, 200)
			assert.equal(res.testRes.body, JSON.stringify({response:"Hello World"}))
		}
	}
}).export(module);
