var vows = require('vows')
var assert = require('assert')
var request = require('request');
var runTestServer = require('./helper.js').runTestServer
var copyProcessEnv = require('./helper.js').copyProcessEnv

vows.describe('Web 2').addBatch({
	"When running a server with a service that responds with the value of a route param": {
		topic: function() {
			runTestServer.call(this, "routeParamTest", function(finishWithServer) {
				request('http://127.0.0.1:3502/blog/techStuff', function (err, response, body) {

					if(err) {
						finishWithServer(err, null)
						return
					} else {
						finishWithServer(null, {
							err: err,
							response: response,
							body: body
						})
					}
				}) // request
			},{DONT_PRINT_TO_CONSOLE:true}) // runTestServer

		},
		"I should see the param value in the response as JSON string": function(res){
			assert.isEmpty(res.stderr)
			assert.isNull(res.testErr)
			assert.equal(res.testRes.response.statusCode, 200)
			assert.equal(res.testRes.body, JSON.stringify({response:"techStuff"}))
		}
	}
}).export(module);
