var vows = require('vows')
var assert = require('assert')
var request = require('request');
var runTestServer = require('./helper.js').runTestServer
var copyProcessEnv = require('./helper.js').copyProcessEnv

vows.describe('Web 3').addBatch({
	"When I run a server with no configuration and no explicit NODE_ENV": {
		topic: function() {
			runTestServer.call(this,"defaultDevPortTest", function(finishWithServer) {
				request('http://127.0.0.1:3500/hello', function (err, response, body) {

						if(err) {
							finishWithServer(err, null)
							return
						} else {
							finishWithServer(null, {
								err: err,
								response: response,
								body: body
							})
						}
					}) // request
			},{DONT_PRINT_TO_CONSOLE:true}) // runTestServer
		},
		"It should serve requests in default port for development 3500": function(res){
			assert.isEmpty(res.stderr)
			assert.isNull(res.testErr)
			assert.equal(res.testRes.response.statusCode, 200)
			assert.equal(res.testRes.body, JSON.stringify({response:"Hello There"}))
		}
	}
}).export(module);
