var vows = require('vows')
var assert = require('assert')
var request = require('request');
var runTestServer = require('./helper.js').runTestServer
var copyProcessEnv = require('./helper.js').copyProcessEnv

vows.describe('Web 4').addBatch({
	"When I run a server with no configuration and in production NODE_ENV": {
		topic: function() {
			var runEnv = copyProcessEnv()
			runEnv.NODE_ENV='production'
			runTestServer.call(this,"defaultProdPortTest", function(finishWithServer) {

				request('http://127.0.0.1/hello', function (err, response, body) {

					if(err) {
						finishWithServer(err, null)
						return
					} else {
						finishWithServer(null, {
							err: err,
							response: response,
							body: body
						});
					}
				}) // request
			},{env:runEnv,DONT_PRINT_TO_CONSOLE:true}) // runTestServer
		},
		"It should serve requests in default port for production 80": function(res){
			assert.isNotEmpty(res.stderr)
			assert.notEqual(res.stderr.indexOf("EACCES"), -1)
		}
	}
}).export(module);
