var vows = require('vows')
var assert = require('assert')
var request = require('request');
var runTestServer = require('./helper.js').runTestServer

vows.describe('Web protocols 1').addBatch({
	"When I run a server with a custom protocol in the config file": {
		topic: function() {
			runTestServer.call(this,"customProtocols", function(finishWithServer) {
				request('http://127.0.0.1:3503/hello', function (err, response, body) {
					
						if(err) {
							finishWithServer(err, null)
							return
						} else {
							finishWithServer(null, {
								err: err,
								response: response,
								body: body
							})
						}
					}) // request
			},{DONT_PRINT_TO_CONSOLE:false}) // runTestServer
		},
		"I should see the value in the response as JSON string": function(res){
			assert.isEmpty(res.stderr)
			assert.isNull(res.testErr)
			assert.equal(res.testRes.response.statusCode, 200)
			assert.equal(res.testRes.body, JSON.stringify({
				"responseBody": "Hello World",
				"customProtocol": "This is being generated from the custom protocol"
			}))
		}
	}
}).export(module);
