var vows = require('vows')
var assert = require('assert')
var request = require('request');
var runTestServer = require('./helper.js').runTestServer

vows.describe('Web protocols 2').addBatch({
	"When I request a route with a custom protocol override": {
		topic: function() {
			runTestServer.call(this,"customProtocolsOverride", function(finishWithServer) {
				request('http://127.0.0.1:3504/useOverride', function (err, response, body) {
						if(err) {
							finishWithServer(err, null)
							return
						} else {
							finishWithServer(null, {
								err: err,
								response: response,
								body: body
							})
						}
					}) // request
			},{DONT_PRINT_TO_CONSOLE:true}) // runTestServer
		},
		"I should see the value in the response as JSON string using the custom protocol override": function(res){
			assert.isEmpty(res.stderr)
			assert.isNull(res.testErr)
			assert.equal(res.testRes.response.statusCode, 200)
			assert.equal(res.testRes.body, JSON.stringify({
				"responseOverrideBody": "Hello World using the Protocol Override",
				"customProtocolOverride": "This is being generated from the custom protocol override"
			}))
		}
	}
}).export(module);
