var vows = require('vows')
var assert = require('assert')
var request = require('request');
var runTestServer = require('./helper.js').runTestServer

vows.describe('Web protocols 3').addBatch({
	"When I request a route with template protocol": {
		topic: function() {
			runTestServer.call(this,"templateProtocol", function(finishWithServer) {
				request('http://127.0.0.1:3506/', function (err, response, body) {
						if(err) {
							finishWithServer(err, null)
							return
						} else {
							finishWithServer(null, {
								err: err,
								response: response,
								body: body
							})
						}
					}) // request
			},{DONT_PRINT_TO_CONSOLE:true}) // runTestServer
		},
		"I should see the value in the response as JSON string using the custom protocol override": function(res){
			assert.isEmpty(res.stderr)
			assert.isNull(res.testErr)
			assert.equal(res.testRes.response.statusCode, 200)
			assert.equal(res.testRes.body, "<h1>Hi There</h1>")
		}
	}
}).export(module);
